﻿Module StandaardFiesenPrrocs

    Public Function GradToRad(ByVal x As Object)
        GradToRad = x * pi / 180
    End Function

    Public Function RadToGrad(ByVal x As Object)
        RadToGrad = x * 180 / pi
    End Function



    Public Function DagNummer(ByVal jaar As Integer, mnd As Integer, dag As Integer)
        Dim p, q As Integer
        p = Int((mnd + 9) / 12)
        q = Int(275 * mnd / 9) - 2 * p + dag - 30
        If (jaar / 4) = Int(jaar / 4) Then
            DagNummer = q + p
        Else
            DagNummer = q
        End If
        'als schrikkeljaar dn = q + p anders dn = q
    End Function



    Public Function L(ByVal dn As Object)
        L = GradToRad(dn * 360 / 365.2424 - 80.412001)
        'L in radialen
    End Function



    'delta = L + 0.4365*SIN( L) + 1.8636*COS( L)- 0.0179*SIN(2L) + 0.0089*COS(2L) in GRADEN
    'declinatie = ARCSIN(SIN LAMBDA * SIN EPSILON)
    Public Function declinatie(ByVal L As Object)
        Dim delta, epsilon As Object
        delta = RadToGrad(L) + 0.4365 * Math.Sin(L) + 1.8636 * Math.Cos(L) - 0.0179 * Math.Sin(2 * L) + 0.0089 * Math.Cos(2 * L)
        delta = GradToRad(delta)
        epsilon = GradToRad(23.43746)
        declinatie = Math.Asin(Math.Sin(delta) * Math.Sin(epsilon))
        'declinatie is de zonsdeclinatie in radialen
    End Function

    Public Function YFlip(ByVal YStart As Object)
        YFlip = Yoorsprong + (Yoorsprong - YStart)
    End Function

End Module
