﻿Module Transformaties

    Sub Omzettingx0yo()
        'omzetting van decl, t in x0, y0, z0
        x0 = Math.Sin(Uurhoek) * Math.Cos(decl)
        y0 = Math.Cos(Uurhoek) * Math.Cos(decl)
        z0 = Math.Sin(decl)
    End Sub

    Sub Omzettingx1y1()
        'omzetting x0, y0, z0, in x1, y1, z1 door rotatie om de x-As met hoek 90 - phi
        Dim R As Object
        R = Math.PI / 2 - phi
        x1 = x0
        y1 = y0 * Math.Cos(R) - z0 * Math.Sin(R)
        z1 = y0 * Math.Sin(R) + z0 * Math.Cos(R)
        'als z1 < 0 dan is de zon onder de horizon.
    End Sub

    Sub Omzettingx2y2()
        'omzetting x1, y1, z1 in x2, y2, z2 door rotatie om de z-as met hoek d
        Dim R As Object
        R = draaiing
        x2 = x1 * Math.Cos(R) - y1 * Math.Sin(R)
        y2 = x1 * Math.Sin(R) + y1 * Math.Cos(R)
        z2 = z1
    End Sub

    Sub Omzettingx3y3()
        'omzetting x2, y2, z2, in x3, y3, z3 door rotatie om de x-As met hoek i
        Dim R As Object
        R = Kantel * Math.Sign(phi)
        x3 = x2
        y3 = y2 * Math.Cos(R) - z2 * Math.Sin(R)
        z3 = y2 * Math.Sin(R) + z2 * Math.Cos(R)
        'als z3 <= 0 dan is de zon niet boven het zonnewijzervlak
    End Sub

    Sub Omzettingx4y4()
        'omzetting x3, y3, z3, in x4, y4 dit zijn de gevraagde coördinaten van het schaduwpunt t.o.v. het zonnewijzer assenstelsel
        x4 = x3 * f * gn / z3
        y4 = y3 * f * gn / z3
    End Sub

    Sub TotaleOmzetting()
        Omzettingx0yo()
        Omzettingx1y1()
        Omzettingx2y2()
        Omzettingx3y3()
        Omzettingx4y4()
    End Sub


    Sub Omzettingxy()
        'omzetting x4, y4 in x, y dit zijn de gevraagde coördinaten van het schaduwpunt t.o.v. het assenstelsel op scherm en printer
        x = Xoorsprong + x4
        y = Yoorsprong + y4
    End Sub


    'Sub X0Y0Z0_uit_X1Y1Z1()
    '    Dim R As Object
    '    R = Math.PI / 2 - phi
    '    x0 = x1
    '    y0 = y1 * Math.Cos(R) + z1 * Math.Sin(R)
    '    z0 = -y1 * Math.Sin(R) + z1 * Math.Cos(R)
    'End Sub



End Module
